<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>UpgradeSnapShotV1.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.upgrade</a> &gt; <span class="el_source">UpgradeSnapShotV1.java</span></div><h1>UpgradeSnapShotV1.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.upgrade;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.InputArchive;
import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.data.StatPersisted;
import org.apache.zookeeper.data.StatPersistedV1;
import org.apache.zookeeper.server.DataNode;
import org.apache.zookeeper.server.DataTree;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.ZooTrace;
import org.apache.zookeeper.server.persistence.FileTxnLog;
import org.apache.zookeeper.server.persistence.Util;
import org.apache.zookeeper.server.util.SerializeUtils;
import org.apache.zookeeper.txn.CreateSessionTxn;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * This class gets the old snapshot 
 * and the old dataDir and creates 
 * an brand new snapshot that is 
 * then converted to the new snapshot
 * for upgrading.           
 */
public class UpgradeSnapShotV1 implements UpgradeSnapShot {
<span class="fc" id="L59">    private static final Logger LOG = LoggerFactory.getLogger(UpgradeSnapShotV1.class);</span>
    
<span class="fc" id="L61">    ConcurrentHashMap&lt;Long, Integer&gt; sessionsWithTimeouts = </span>
        new ConcurrentHashMap&lt;Long, Integer&gt;();
    File dataDir;
    File snapShotDir;
    DataTreeV1 oldDataTree;
   
    /**
     * upgrade from version 1 to version 2
     * @param dataDir
     * @param snapShotDir
     */
<span class="fc" id="L72">    public UpgradeSnapShotV1(File dataDir, File snapShotDir) {</span>
<span class="fc" id="L73">        this.dataDir = dataDir;</span>
<span class="fc" id="L74">        this.snapShotDir = snapShotDir;</span>
<span class="fc" id="L75">        oldDataTree = new DataTreeV1();</span>
<span class="fc" id="L76">    }</span>
    
    /**
     * deseriluize from an inputarchive
     * @param oldTree the tree to be created
     * @param ia the input archive to be read from
     * @param sessions the sessions to be created
     * @throws IOException 
     */
    private void deserializeSnapshot(DataTreeV1 oldTree, InputArchive ia,
            Map&lt;Long, Integer&gt; sessions) throws IOException {
<span class="fc" id="L87">        int count = ia.readInt(&quot;count&quot;);</span>
<span class="fc bfc" id="L88" title="All 2 branches covered.">        while (count &gt; 0) {</span>
<span class="fc" id="L89">            long id = ia.readLong(&quot;id&quot;);</span>
<span class="fc" id="L90">            int to = ia.readInt(&quot;timeout&quot;);</span>
<span class="fc" id="L91">            sessions.put(id, to);</span>
<span class="pc bpc" id="L92" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L93">                ZooTrace.logTraceMessage(LOG, ZooTrace.SESSION_TRACE_MASK,</span>
                        &quot;loadData --- session in archive: &quot; + id
                        + &quot; with timeout: &quot; + to);
            }
<span class="fc" id="L97">            count--;</span>
<span class="fc" id="L98">        }</span>
<span class="fc" id="L99">        oldTree.deserialize(ia, &quot;tree&quot;);</span>
<span class="fc" id="L100">    }</span>
    
    /**
     * play the log from this logstream into the datatree
     * @param logStream
     * @return
     * @throws IOException
     */
    public long playLog(InputArchive logStream) throws IOException {
<span class="fc" id="L109">        long highestZxid = 0;</span>
        try {
            while (true) {
<span class="fc" id="L112">                byte[] bytes = logStream.readBuffer(&quot;txnEntry&quot;);</span>
<span class="fc bfc" id="L113" title="All 2 branches covered.">                if (bytes.length == 0) {</span>
                    // Since we preallocate, we define EOF to be an
                    // empty transaction
<span class="fc" id="L116">                    throw new EOFException();</span>
                }
<span class="fc" id="L118">                TxnHeader hdr = new TxnHeader();</span>
<span class="fc" id="L119">                Record txn = SerializeUtils.deserializeTxn(bytes, hdr);</span>
<span class="pc bpc" id="L120" title="1 of 2 branches missed.">                if (logStream.readByte(&quot;EOR&quot;) != 'B') {</span>
<span class="nc" id="L121">                    LOG.warn(&quot;Last transaction was partial.&quot;);</span>
<span class="nc" id="L122">                    throw new EOFException(&quot;Last transaction was partial.&quot;);</span>
                }
<span class="pc bpc" id="L124" title="3 of 4 branches missed.">                if (hdr.getZxid() &lt;= highestZxid &amp;&amp; highestZxid != 0) {</span>
<span class="nc" id="L125">                    LOG.error(highestZxid + &quot;(higestZxid) &gt;= &quot;</span>
<span class="nc" id="L126">                            + hdr.getZxid() + &quot;(next log) for type &quot;</span>
<span class="nc" id="L127">                            + hdr.getType());</span>
                } else {
<span class="fc" id="L129">                    highestZxid = hdr.getZxid();</span>
                }
<span class="fc bfc" id="L131" title="All 3 branches covered.">                switch (hdr.getType()) {</span>
                case OpCode.createSession:
<span class="fc" id="L133">                    sessionsWithTimeouts.put(hdr.getClientId(),</span>
<span class="fc" id="L134">                            ((CreateSessionTxn) txn).getTimeOut());</span>
<span class="pc bpc" id="L135" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L136">                        ZooTrace.logTraceMessage(LOG,</span>
                                                 ZooTrace.SESSION_TRACE_MASK,
                                &quot;playLog --- create session in log: 0x&quot;
<span class="nc" id="L139">                                        + Long.toHexString(hdr.getClientId())</span>
                                        + &quot; with timeout: &quot;
<span class="nc" id="L141">                                        + ((CreateSessionTxn) txn).getTimeOut());</span>
                    }
                    // give dataTree a chance to sync its lastProcessedZxid
<span class="fc" id="L144">                    oldDataTree.processTxn(hdr, txn);</span>
<span class="fc" id="L145">                    break;</span>
                case OpCode.closeSession:
<span class="fc" id="L147">                    sessionsWithTimeouts.remove(hdr.getClientId());</span>
<span class="pc bpc" id="L148" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L149">                        ZooTrace.logTraceMessage(LOG,</span>
                                ZooTrace.SESSION_TRACE_MASK,
                                &quot;playLog --- close session in log: 0x&quot;
<span class="nc" id="L152">                                        + Long.toHexString(hdr.getClientId()));</span>
                    }
<span class="fc" id="L154">                    oldDataTree.processTxn(hdr, txn);</span>
<span class="fc" id="L155">                    break;</span>
                default:
<span class="fc" id="L157">                    oldDataTree.processTxn(hdr, txn);</span>
                }
<span class="fc" id="L159">                Request r = new Request(null, 0, hdr.getCxid(), hdr.getType(),</span>
                        null, null);
<span class="fc" id="L161">                r.txn = txn;</span>
<span class="fc" id="L162">                r.hdr = hdr;</span>
<span class="fc" id="L163">                r.zxid = hdr.getZxid();</span>
<span class="fc" id="L164">            }</span>
<span class="fc" id="L165">        } catch (EOFException e) {</span>
            // expected in some cases - see comments in try block
        }
<span class="fc" id="L168">        return highestZxid;</span>
    }

   
    
    /**
     * apply the log files to the datatree
     * @param oldTree the datatreee to apply the logs to
     * @param logFiles the logs to be applied
     * @throws IOException
     */
    private long processLogFiles(DataTreeV1 oldTree, 
            File[] logFiles) throws IOException {
<span class="fc" id="L181">        long zxid = 0;</span>
<span class="fc bfc" id="L182" title="All 2 branches covered.">        for (File f: logFiles) { </span>
<span class="fc" id="L183">            LOG.info(&quot;Processing log file: &quot; + f);</span>
<span class="fc" id="L184">            InputStream logIs = </span>
                new BufferedInputStream(new FileInputStream(f));
<span class="fc" id="L186">            zxid = playLog(BinaryInputArchive.getArchive(logIs));</span>
<span class="fc" id="L187">            logIs.close();</span>
        }
<span class="fc" id="L189">        return zxid;</span>
    }
    
    /**
     * create the old snapshot database
     * apply logs to it and create the final
     * database
     * @throws IOException
     */
    private void loadThisSnapShot() throws IOException {  
        // pick the most recent snapshot
<span class="fc" id="L200">        File snapshot = findMostRecentSnapshot();</span>
<span class="pc bpc" id="L201" title="1 of 2 branches missed.">        if (snapshot == null) {</span>
<span class="nc" id="L202">            throw new IOException(&quot;Invalid snapshots &quot; +</span>
            		&quot;or not snapshots in &quot; + snapShotDir);
        }
<span class="fc" id="L205">        InputStream inputstream = new BufferedInputStream(</span>
                new FileInputStream(snapshot));
<span class="fc" id="L207">        InputArchive ia = BinaryInputArchive.getArchive(inputstream);</span>
<span class="fc" id="L208">        deserializeSnapshot(oldDataTree, ia, sessionsWithTimeouts);</span>
        //ok done with the snapshot 
        // now apply the logs
<span class="fc" id="L211">        long snapshotZxid = oldDataTree.lastProcessedZxid;</span>
<span class="fc" id="L212">        File[] files = FileTxnLog.getLogFiles(</span>
<span class="fc" id="L213">                dataDir.listFiles(), snapshotZxid);</span>
<span class="fc" id="L214">        long zxid = processLogFiles(oldDataTree, files);</span>
        //check for this zxid to be sane
<span class="pc bpc" id="L216" title="1 of 2 branches missed.">        if (zxid != oldDataTree.lastProcessedZxid) {</span>
<span class="nc" id="L217">            LOG.error(&quot;Zxids not equal &quot; + &quot; log zxid &quot; +</span>
                    zxid + &quot; datatree processed &quot; + oldDataTree.lastProcessedZxid);
        }
<span class="fc" id="L220">    }</span>
    
    /**
     * find the most recent snapshot 
     * in the snapshot directory
     * @return
     * @throws IOException
     */
    private File findMostRecentSnapshot() throws IOException {
<span class="fc" id="L229">        List&lt;File&gt; files = Util.sortDataDir(snapShotDir.listFiles(),</span>
                &quot;snapshot&quot;, false);
<span class="pc bpc" id="L231" title="1 of 2 branches missed.">        for (File f: files) {</span>
            try {
<span class="pc bpc" id="L233" title="1 of 2 branches missed.">                if (Util.isValidSnapshot(f))</span>
<span class="fc" id="L234">                    return f;</span>
<span class="nc" id="L235">            } catch(IOException e) {</span>
<span class="nc" id="L236">                LOG.info(&quot;Invalid snapshot &quot; + f, e);</span>
<span class="nc" id="L237">            }</span>
<span class="nc" id="L238">        }</span>
<span class="nc" id="L239">        return null;</span>
    }
    
    /**
     * convert the old stat to new stat
     * @param oldStat the old stat
     * @return the new stat
     */
    private StatPersisted convertStat(StatPersistedV1 oldStat) {
<span class="fc" id="L248">        StatPersisted stat = new StatPersisted();</span>
<span class="fc" id="L249">        stat.setAversion(oldStat.getAversion());</span>
<span class="fc" id="L250">        stat.setCtime(oldStat.getCtime());</span>
<span class="fc" id="L251">        stat.setCversion(oldStat.getCversion());</span>
<span class="fc" id="L252">        stat.setCzxid(oldStat.getCzxid());</span>
<span class="fc" id="L253">        stat.setEphemeralOwner(oldStat.getEphemeralOwner());</span>
<span class="fc" id="L254">        stat.setMtime(oldStat.getMtime());</span>
<span class="fc" id="L255">        stat.setMzxid(oldStat.getMzxid());</span>
<span class="fc" id="L256">        stat.setVersion(oldStat.getVersion());</span>
<span class="fc" id="L257">        return stat;</span>
    }
    
    /**
     * convert a given old datanode to new datanode
     * @param dt the new datatree
     * @param parent the parent of the datanode to be constructed
     * @param oldDataNode the old datanode 
     * @return the new datanode
     */
    private DataNode convertDataNode(DataTree dt, DataNode parent, 
            DataNodeV1 oldDataNode) {
<span class="fc" id="L269">        StatPersisted stat = convertStat(oldDataNode.stat);</span>
<span class="fc" id="L270">        DataNode dataNode =  new DataNode(parent, oldDataNode.data,</span>
<span class="fc" id="L271">                dt.convertAcls(oldDataNode.acl), stat);</span>
<span class="fc" id="L272">        dataNode.setChildren(oldDataNode.children);</span>
<span class="fc" id="L273">        return dataNode;</span>
    }
    
    /**
     * recurse through the old datatree and construct the 
     * new data tree
     * @param dataTree the new datatree to be constructed
     * @param path the path to start with
     */
    private void recurseThroughDataTree(DataTree dataTree, String path) {
<span class="pc bpc" id="L283" title="1 of 2 branches missed.">        if (path == null)</span>
<span class="nc" id="L284">            return;</span>
<span class="fc" id="L285">        DataNodeV1 oldDataNode = oldDataTree.getNode(path);</span>
<span class="fc" id="L286">        HashSet&lt;String&gt; children = oldDataNode.children;</span>
<span class="fc" id="L287">        DataNode parent = null;</span>
<span class="fc bfc" id="L288" title="All 2 branches covered.">        if (&quot;&quot;.equals(path)) {</span>
<span class="fc" id="L289">            parent = null;</span>
        }
        else {
<span class="fc" id="L292">            int lastSlash = path.lastIndexOf('/');</span>
<span class="fc" id="L293">            String parentPath = path.substring(0, lastSlash);</span>
<span class="fc" id="L294">            parent = dataTree.getNode(parentPath);</span>
        }
<span class="fc" id="L296">        DataNode thisDatNode = convertDataNode(dataTree, parent,</span>
                                    oldDataNode);
<span class="fc" id="L298">        dataTree.addDataNode(path, thisDatNode);</span>
<span class="pc bpc" id="L299" title="1 of 4 branches missed.">        if (children == null || children.size() == 0) {</span>
<span class="fc" id="L300">            return;</span>
        }
        else {
<span class="fc bfc" id="L303" title="All 2 branches covered.">            for (String child: children) {</span>
<span class="fc" id="L304">                recurseThroughDataTree(dataTree, path + &quot;/&quot; +child);</span>
<span class="fc" id="L305">            }</span>
        }
<span class="fc" id="L307">    }   </span>
    
    private DataTree convertThisSnapShot() throws IOException {
        // create a datatree 
<span class="fc" id="L311">        DataTree dataTree = new DataTree();</span>
<span class="fc" id="L312">        DataNodeV1 oldDataNode = oldDataTree.getNode(&quot;&quot;);</span>
<span class="pc bpc" id="L313" title="1 of 2 branches missed.">        if (oldDataNode == null) {</span>
            //should never happen
<span class="nc" id="L315">            LOG.error(&quot;Upgrading from an empty snapshot.&quot;);</span>
        }
        
<span class="fc" id="L318">        recurseThroughDataTree(dataTree, &quot;&quot;);</span>
<span class="fc" id="L319">        dataTree.lastProcessedZxid = oldDataTree.lastProcessedZxid;</span>
<span class="fc" id="L320">        return dataTree;</span>
    }
    
    public DataTree getNewDataTree() throws IOException {
<span class="fc" id="L324">        loadThisSnapShot();</span>
<span class="fc" id="L325">        DataTree dt = convertThisSnapShot();</span>
<span class="fc" id="L326">        return dt;</span>
    }
    
    public ConcurrentHashMap&lt;Long, Integer&gt; getSessionWithTimeOuts() {
<span class="fc" id="L330">        return this.sessionsWithTimeouts;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>